---
title: Release Note v1.8.10
authors: moonrailgun
image: /img/logo.svg
slug: release-1.8.10
keywords:
  - tailchat
tags: [Release Note]
---

### Feature update

#### Added the ability to create converse from groups

![](/img/blog/release-note/v1.8.10/1.png)

In the user avatar pop-up layer in the group conversation, a button to quickly start the conversation is added, which can conveniently send private messages to the users in the group.

If the group manager does not want group members to initiate private messages, they can actively close it in the group settings.

![](/img/blog/release-note/v1.8.10/2.png)

### Other Updates

- Add refresh operation to admin message list
- Fix the risk of unauthorized message sending [#143](https://github.com/msgbyte/tailchat/issues/143)
  - Added all session permissions for plugin bots (not open platform bots)
- Fixed the problem that the receiving message taskbar could not flash on the desktop
- Fixed an issue where the logo flickered when hovering over the group list with a scroll bar
- Fix the problem that the danger button color is wrong in light mode
- Fix the problem that the cache key of userSetting is incorrect
- Fixed the problem that you can still use the input box on the right in the chat box after being banned
- For some high-frequency requests (parts with front-end cache before), a persistent cache is added to reduce the impact of front-end cache invalidation caused by frequent page refreshes on back-end services
- Optimize the display strategy of user avatars in the admin background, and remove problems caused by null/undefined
- Optimize the size of the feature bar icon on the homepage of the official website, the current volume is about 1/3 of the original
- Increase the database index and optimize the request time consumption of the `fetchConverseMessage` operation in the case of a large amount of data
- Optimize the update group configuration interaction under low-speed network
- Optimize the entry file size of the `sentry` plugin to reduce the time spent on first loading
