---
sidebar_position: 1
title: Summary
---

`Tailchat` is an open source IM application that is pluggable and easy to expand. Plugin architecture gives `Tailchat` unlimited possibilities.

Front-end micro-kernel architecture + back-end micro-service architecture makes `Tailchat` to control any customized/privatized scenarios

Created for enterprises and private domain users, highly free group management and customized panel display allow private domain owners to better display their works, manage users, and build their own brand and circle.

## Feature

- Complete basic ability of instant messaging
- The free expansion ability endowed by the plugin architecture
- The horizontal expansion capability endowed by the microservice architecture

## Highlight

- The front-end micro-kernel architecture based on [mini-star](https://ministar.moonrailgun.com/) and the back-end micro-service architecture based on [moleculer](https://moleculer.services/) can adapt to various user usage, easy to expand
- A complete chat system that supports various syntaxes such as mentions, panel jumps, rich text, markdown, url links, etc.
- Message reaction mechanism, allowing you to express yourself through expressions
- File sharing and image sending
- Support voice calls and video calls
- Perfect identity group management, RBAC
- User Management and User Muting
- Email authentication and password retrieval
- Various panels: web page embedding, custom html, topic panel
- Simple message push and github notification subscription
- Admin platform
- Openapi platform
  - Bot
  - OAuth
- More wonderful chemical reactions brought by plugins
  - custom theme
  - listen to music online
  - message encryption
  - fetch link metadata
  - Airdrop
  - Task
  - Draw
  - Font size
  - Toolbox
  - ...

## Technology Stack

- Frontend
  - `React`
  - `Redux`
  - `mini-star`
  - `tailwindcss`
  - `iconify`
- Backend
  - `Nodejs`
  - `Socket.io`
  - `koa`
  - `moleculer`

## Screenshot

#### Overview

![](/img/intro/hello.png)

#### Plugin Center

![](/img/intro/plugins.png)

#### Themes

![](/img/intro/theme.png)

#### Roles & Permission

![](/img/intro/roles.png)

#### Github Subscription Bot

![](/img/intro/github-bot.png)

#### Admin

![](/img/intro/admin-network.png)

## Open Source Agreement

For open source agreements, please mainly refer to the following documents:

[Apache 2.0](https://github.com/msgbyte/tailchat/blob/master/LICENSE)
