---
sidebar_position: 1
title: 关于开放平台
---

开放平台是常见且传统的应用与应用之间进行交互的方式，对于一些简单的需求我们可以通过开放平台来实现应用之间的数据传递。

在 Tailchat 中。目前主要提供两种形式的开放平台应用能力: `OAuth` 与 `Bot`

## 功能介绍

### OAuth

`OAuth` 能够使外部应用能够通过`Tailchat`的账号登录，就像是 `Google`, `Github` 登录方式一样，可以方便用户打造基于 `Tailchat` 的统一用户平台

:::info
与 `com.msgbyte.iam` 插件的区别: `iam`插件是提供外部账号登录`Tailchat`的方式，如使用`Github`账号登录`Tailchat`, 而开放平台的OAuth能力则是以`Tailchat`账号登录其他平台。
:::

[了解更多](./oauth)

### Bot

`Bot` 赋予聊天机器人可交互的应用能力，这意味着 Tailchat 不仅仅可以被动接收来自外部的消息，也可以主动将内部聊天的请求转发到外部应用代为处理。

[了解更多](./bot)

## 使用前提

在使用开放平台的相关能力前，请确保安装了对应的插件，并确保管理员已经部署与开放了相关的开放平台的能力。

作为用户，你需要安装 `com.msgbyte.integration` 插件来将应用加入到自己的群组

作为开放平台应用的开发者，你需要额外安装 `com.msgbyte.openapi` 来展示开放平台应用相关所需要的界面
