---
sidebar_position: 1
title: 概述
---

`Tailchat` 是一款插件化易拓展的开源 IM 应用。可拓展架构赋予 `Tailchat` 无限可能性。

前端微内核架构 + 后端微服务架构 使得 `Tailchat` 能够驾驭任何定制化/私有化的场景

面向企业与私域用户打造，高度自由的群组管理与定制化的面板展示可以让私域主能够更好的展示自己的作品，管理用户，打造自己的品牌与圈子。

## 特性

- 完整的即时通讯基础能力
- 插件化架构的赋予的自由拓展能力
- 微服务架构赋予的水平拓展能力

## 亮点

- 基于[mini-star](https://ministar.moonrailgun.com/)的前端微内核架构与基于[moleculer](https://moleculer.services/)的后端微服务架构可以适应各种用户用量，便于拓展
- 完整的聊天系统，支持提及、面板跳转、富文本、markdown、url链接等各种语法
- 消息reaction机制，让你通过表情表达自己
- 文件分享与图片发送
- 支持语音通话与视频通话
- 完善的身份组管理，权限控制颗粒化
- 用户管理与用户禁言
- 邮箱认证与密码找回
- 多种面板: 网页嵌入, 自定义html, 话题面板
- 简易消息推送与github通知订阅
- 后台管理平台
- 开放平台
  - 机器人
  - OAuth
- 插件带来的更多奇妙化学反应
  - 自定义主题
  - 在线听音乐
  - 消息加密
  - url获取元数据
  - 隔空投送
  - 任务管理
  - 在线绘图
  - 字体放大
  - 工具箱
  - ...

## 技术栈

- 前端
  - `React`
  - `Redux`
  - `mini-star`
  - `tailwindcss`
  - `iconify`
- 后端
  - `Nodejs`
  - `Socket.io`
  - `koa`
  - `moleculer`

## 截图

#### 概览

![](/img/intro/hello.png)

#### 插件中心

![](/img/intro/plugins.png)

#### 各类主题

![](/img/intro/theme.png)

#### 身份组与权限管理

![](/img/intro/roles.png)

#### Github订阅机器人

![](/img/intro/github-bot.png)

#### Admin 后台管理

![](/img/intro/admin-network.png)

## 开源协议

开源协议请主要参考以下文档:

[Apache 2.0](https://github.com/msgbyte/tailchat/blob/master/LICENSE)
